import type {Dependencies, Signature} from '../interfaces/type.js'
import {$reflect} from '../interfaces/type.js'

export const square = $reflect!('square',
   <T>(dep: Dependencies<'multiply', T>) => (z:T) => dep.multiply(z, z))
   // z => dep.fooBar(z, z) // fails as desired
   // z => dep.multiply(z, 'foo') // still fails as desired
